//+------------------------------------------------------------------+
//|                                       McGinley Dynamic indicator |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 DeepSkyBlue

extern int Length = 12;
extern int Price = PRICE_CLOSE;

double buff[];
double emas[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(2);
   SetIndexBuffer(0,buff);
   SetIndexBuffer(1,emas);

   string PriceType;
      switch(Price)
      {
         case PRICE_CLOSE:    PriceType = "Close";    break;  // 0
         case PRICE_OPEN:     PriceType = "Open";     break;  // 1
         case PRICE_HIGH:     PriceType = "High";     break;  // 2
         case PRICE_LOW:      PriceType = "Low";      break;  // 3
         case PRICE_MEDIAN:   PriceType = "Median";   break;  // 4
         case PRICE_TYPICAL:  PriceType = "Typical";  break;  // 5
         case PRICE_WEIGHTED: PriceType = "Weighted"; break;  // 6
      }      

   Length = MathMax(Length ,1);
   IndicatorShortName (" McGinley Dynamic ("+Length+","+PriceType+")");
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#define iPrc 6

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit = MathMin(Bars-counted_bars,Bars-1);

   // Ref(Mov(C,12,E),-1)+((C-(Ref(Mov(C,12,E),-1))) / (C/(Ref(Mov(C,12,E),-1))*125))

   for(i=limit; i >= 0; i--)
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,Price,i);
             emas[i] = iMA(NULL,0,Length,0,MODE_EMA,Price,i);
             if (emas[i+1]!=0)
                  buff[i] = emas[i+1]+((price-emas[i+1])/(price/emas[i+1]*125.00));
             else buff[i] = 0;
   }
   return(0);
}